
;----------------------------------------------------------------------
; Reads a file containing a console screen format into an array
; of structure CHAR_INFO totalling 8000 bytes, and invoke the API
; to display it all at once: WriteConsoleOutput(). Wait a key and
; terminates the program.
;----------------------------------------------------------------------
; Input file: menusys.txt
;----------------------------------------------------------------------
; Author: frktons @ MASM32 forum
; Date: 19/aug/2010. 
;---------------------------------------------------------------------- 


include \masm32\include\masm32rt.inc

Console80x25 PROTO


.data

        bytecount dd 8000 ; Bytes to read from input file
        ConTitle  db "Win32 Console 80 x 25 Fixed Size - Menu System", 0   
        inpbyte   DWORD  1  
          
         

.data?

        charArray     CHAR_INFO 2000 dup (<>)
   

        hFile     HANDLE ? 
        cci       CONSOLE_CURSOR_INFO <>        


        wHnd      HANDLE ? 
        rHnd      HANDLE ?

        windowSize SMALL_RECT <>
        bufferSize COORD      <>
        startPoint COORD      <>


.code

start:  

        mov hFile, fopen("menusys.txt")

        mov ebx, fread(hFile, offset charArray, bytecount)
    
        print "Bytes read from input file: "
        print str$(ebx),13,10

        fclose hFile

        invoke GetStdHandle, STD_OUTPUT_HANDLE
        mov    wHnd,eax

        mov windowSize.Left, 0
        mov windowSize.Right, 79
        mov windowSize.Top, 0
        mov windowSize.Bottom, 24
   

        mov bufferSize.x, 80
        mov bufferSize.y, 25

        mov startPoint.x, 0
        mov startPoint.y, 0

        invoke SetConsoleTitle, ADDR ConTitle
        call   hidecursor
        

        invoke Console80x25

        invoke GetStdHandle, STD_INPUT_HANDLE
        mov rHnd,eax

        invoke ReadConsole, rHnd, ADDR inpbyte, 1, NULL, NULL
        call   showcursor

finish: invoke ExitProcess,0

        ret
   

Console80x25 PROC


    invoke SetConsoleWindowInfo, wHnd, TRUE, ADDR windowSize

    invoke SetConsoleScreenBufferSize, wHnd, DWORD PTR bufferSize



    inkey "Press a key to display the content screen" 


    invoke WriteConsoleOutput, wHnd, offset charArray, DWORD PTR bufferSize, DWORD PTR startPoint, offset windowSize 

    ret

Console80x25 ENDP


; -------------------------------------------------------------------------

hidecursor:
    invoke GetConsoleCursorInfo,wHnd,addr cci
    mov cci.bVisible,FALSE
    invoke SetConsoleCursorInfo,wHnd,addr cci
    ret

; -------------------------------------------------------------------------

showcursor:
    invoke GetConsoleCursorInfo,wHnd,addr cci
    mov cci.bVisible,TRUE
    invoke SetConsoleCursorInfo,wHnd,addr cci
    ret

; -------------------------------------------------------------------------


end start